# Aurelia • [TodoMVC](http://todomvc.com)

> *Aurelia* is a next generation JavaScript client framework that leverages simple conventions to empower your creativity.


## Local Installation

Requirements:

- [NodeJS](http://nodejs.org/download/)
- [jspm](http://jspm.io/)
- [gulp](http://gulpjs.com/)

Clone the repository:

```
$ git clone https://github.com/mhoyer/todomvc-aurelia
```

Install jspm and npm packages:

```
$ npm install
$ jspm install
```

Simply build, test, bundle, export:

```
$ gulp
```

Run tests and HTTP-server:

```
$ gulp watch
```


## Resources

- [Aurelia • TodoMVC](https://github.com/mhoyer/todomvc-aurelia) original sources
- [Website](http://aurelia.io/)
- [Documentation](http://aurelia.io/docs.html)
- [Blog](http://blog.durandal.io/)

### Support

- [Twitter](http://twitter.com/pixelplastic)
- [Gitter](https://gitter.im/Aurelia/Discuss)

*Let us [know](https://github.com/tastejs/todomvc/issues) if you discover anything worth sharing.*


## Implementation

- Following the getting started tutorial: http://aurelia.io/get-started.html
- Attempt to go TDD where possible

### Changelog

#### 0.1.0

- Finished functional implementation to fulfill [TodoMVC Application Specification](https://github.com/tastejs/todomvc/blob/master/app-spec.md)
- Includes bundling (jspm) and exporting (for easy sync with [todomvc/examples/aurelia](https://github.com/tastejs/todomvc/tree/master/examples/aurelia))

### Open Questions While Developing

- See [Issues](https://github.com/mhoyer/todomvc-aurelia/issues/)


## Credit

Created by [Marcel Hoyer](http://marcelhoyer.de)
